> ## Documentation Index
> Fetch the complete documentation index at: https://docs.hookstream.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a connection

Create a new connection between a source and a destination.

` POST /connections `

Create a connection

Create a new connection between a source and a destination.

## Servers

- ` https://hookstream.io/v1 ` — Production

## Authentication

The operation accepts these alternatives. Schemes within one alternative are required together.

### Alternative 1

- ` apiKey `: ` apiKey `

  - Credential: ` X-API-Key ` in ` header `

  - API key (format: hs_live_<64hex> or hs_test_<64hex>)

### Alternative 2

- ` cookieAuth `: ` apiKey `

  - Credential: ` better-auth.session_token ` in ` cookie `

  - Session cookie (browser auth)

## Request body (required)

Content type: ` application/json `

Request body

- ` value `: type ` object `

  - Required fields: ` source_id `, ` destination_id `, ` name `

  - ` org_id `: type ` string ` — Organization ID (defaults to auth context)

  - ` env_id `: type ` string ` — Environment ID (defaults to auth context)

  - ` source_id `: type ` string ` — Source ID to connect from

    - minLength: ` 1 `

  - ` destination_id `: type ` string ` — Destination ID to connect to

    - minLength: ` 1 `

  - ` name `: type ` string ` — Connection name

    - minLength: ` 1 `

  - ` description `: type ` string ` — Connection description

  - ` filter_rules `: type ` array ` — Content-based filter rules

    - ` array item `: type ` object `

  - ` enabled `: type ` boolean ` — Whether the connection is enabled

    - default: ` true `

  - ` transform_enabled `: type ` boolean ` — Enable JSONata transform

  - ` transform_expression `: type ` string ` — JSONata transform expression

## Responses

### ` 201 ` — Created connection

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` connection `

  - ` connection `: type ` object `; nullable

    - Required fields: ` id `, ` org_id `, ` env_id `, ` source_id `, ` destination_id `, ` name `, ` description `, ` enabled `, ` filter_rules `, ` status `, ` event_count `, ` last_event_at `, ` created_at `, ` updated_at `, ` transform_enabled `, ` transform_expression `, ` source_name `, ` destination_name `

    - ` id `: type ` string `

    - ` org_id `: type ` string `

    - ` env_id `: type ` string `

    - ` source_id `: type ` string `

    - ` destination_id `: type ` string `

    - ` name `: type ` string `

    - ` description `: type ` string `; nullable

    - ` enabled `: type ` integer `

    - ` filter_rules `: type ` string `; nullable

    - ` status `: type ` string `

    - ` event_count `: type ` integer `

    - ` last_event_at `: type ` string `; nullable

    - ` created_at `: type ` string `

    - ` updated_at `: type ` string `

    - ` transform_enabled `: type ` integer `

    - ` transform_expression `: type ` string `; nullable

    - ` source_name `: type ` string `; nullable

    - ` destination_name `: type ` string `; nullable

### ` 400 ` — Validation error

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` error `

  - ` error `: type ` string ` — Error message

### ` 401 ` — Unauthorized

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` error `

  - ` error `: type ` string ` — Error message

### ` 404 ` — Source or destination not found

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` error `

  - ` error `: type ` string ` — Error message

## Request examples

### cURL

```curl
curl -X POST 'https://hookstream.io/v1/connections' \
  -H 'Authorization: Bearer YOUR_API_TOKEN' \
  -H 'Content-Type: application/json' \
  -d '{
  "org_id": "string",
  "env_id": "string",
  "source_id": "string",
  "destination_id": "string",
  "name": "string",
  "description": "string",
  "filter_rules": [
    {}
  ],
  "enabled": true,
  "transform_enabled": true,
  "transform_expression": "string"
}'
```

### JavaScript

```javascript
const response = await fetch('https://hookstream.io/v1/connections', {
  method: 'POST',
  headers: {
      "Authorization": "Bearer YOUR_API_TOKEN",
      "Content-Type": "application/json"
  },
  body: JSON.stringify({
    "org_id": "string",
    "env_id": "string",
    "source_id": "string",
    "destination_id": "string",
    "name": "string",
    "description": "string",
    "filter_rules": [
      {}
    ],
    "enabled": true,
    "transform_enabled": true,
    "transform_expression": "string"
  })
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

headers = {
    'Authorization': 'Bearer YOUR_API_TOKEN'
}

response = requests.post('https://hookstream.io/v1/connections', headers=headers, json={
  "org_id": "string",
  "env_id": "string",
  "source_id": "string",
  "destination_id": "string",
  "name": "string",
  "description": "string",
  "filter_rules": [
    {}
  ],
  "enabled": true,
  "transform_enabled": true,
  "transform_expression": "string"
})
print(response.json())
```

### Go

```go
package main

import (
	"fmt"
	"io"
	"net/http"
	"strings"
)

func main() {
	body := strings.NewReader(`{
  "org_id": "string",
  "env_id": "string",
  "source_id": "string",
  "destination_id": "string",
  "name": "string",
  "description": "string",
  "filter_rules": [
    {}
  ],
  "enabled": true,
  "transform_enabled": true,
  "transform_expression": "string"
}`)
	req, _ := http.NewRequest("POST", "https://hookstream.io/v1/connections", body)
	req.Header.Set("Authorization", "Bearer YOUR_API_TOKEN")
	req.Header.Set("Content-Type", "application/json")

	resp, _ := http.DefaultClient.Do(req)
	defer resp.Body.Close()
	result, _ := io.ReadAll(resp.Body)
	fmt.Println(string(result))
}
```